.\"	$NetBSD: realpath.3,v 1.11 2003/08/07 16:42:55 agc Exp $
.\"
.\" Copyright (c) 1994
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" This code is derived from software contributed to Berkeley by
.\" Jan-Simon Pendry.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)realpath.3	8.2 (Berkeley) 2/16/94
.\"
.Dd August 13, 2005
.Dt REALPATH 3
.Os
.Sh NAME
.Nm realpath
.Nd returns the canonicalized absolute pathname
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In sys/param.h
.In stdlib.h
.Ft "char *"
.Fn realpath "const char *pathname" "char resolvedname[MAXPATHLEN]"
.Sh DESCRIPTION
The
.Fn realpath
function resolves all symbolic links, extra
.Dq /
characters and references to
.Pa /./
and
.Pa /../
in
.Fa pathname ,
and copies the resulting absolute pathname into
the memory referenced by
.Fa resolvedname .
The
.Fa resolvedname
argument
.Em must
refer to a buffer capable of storing at least
.Dv MAXPATHLEN
characters.
.Pp
The
.Fn realpath
function will resolve both absolute and relative paths
and return the absolute pathname corresponding to
.Fa pathname .
.Sh RETURN VALUES
The
.Fn realpath
function returns
.Fa resolvedname
on success.
If an error occurs,
.Fn realpath
returns
.Dv NULL ,
and
.Fa resolvedname
contains the pathname which caused the problem.
.Sh ERRORS
The function
.Fn realpath
may fail and set the external variable
.Va errno
for any of the errors specified for the library functions
.Xr chdir 2 ,
.Xr close 2 ,
.Xr fchdir 2 ,
.Xr lstat 2 ,
.Xr open 2 ,
.Xr readlink 2
and
.Xr getcwd 3 .
.Sh SEE ALSO
.Xr getcwd 3
.Sh HISTORY
The
.Fn realpath
function call first appeared in
.Bx 4.4 .
.Sh BUGS
This implementation of
.Fn realpath
differs slightly from the Solaris implementation.
The
.Bx 4.4
version always returns absolute pathnames,
whereas the Solaris implementation will,
under certain circumstances, return a relative
.Fa resolvedname
when given a relative
.Fa pathname .
